use std::{error::Error, fmt, fmt::Display};

#[derive(Debug, PartialEq)]
pub struct ElasticError {
    pub message: String,
}

impl ElasticError {
    pub fn new(message: &str) -> Self {
        Self {
            message: message.to_string(),
        }
    }
}

impl Display for ElasticError {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        write!(f, "{}", &self.message)
    }
}

impl Error for ElasticError {}

impl From<ElasticError> for std::io::Error {
    fn from(e: ElasticError) -> Self {
        Self::new(std::io::ErrorKind::InvalidInput, e.message)
    }
}
